//=======================================================================================
// Copyright(c) 2017 Nuvoton(SH) Technology Corp. All rights reserved.                   
// Website: http://www.nuvoton.com
// Date   : 6/1/2017
//=======================================================================================
#include "N76E003.h"
#include "SFR_Macro.h"
#include "Function_define.h"

#define UARTLOOP 16
uint8_t u8Uart_Data[UARTLOOP];
uint8_t UartFirst,UartLast;
bit Flag_receive;
bit BIT_TI;

bit BIT_TMP;


void MODIFY_HIRC_16588(void)
{
	unsigned char hircmap0,hircmap1;
	unsigned int  trimvalue16bit;
	set_IAPEN;
	IAPAL = 0x30;
	IAPAH = 0x00;
	IAPCN = 0x04;
	set_IAPGO;
	hircmap0 = IAPFD;
	IAPAL = 0x31;
	IAPAH = 0x00;
	set_IAPGO;
	hircmap1 = IAPFD;
	clr_IAPEN;
	hircmap1 = hircmap1&0x01;
	trimvalue16bit = ((hircmap0<<1)+(hircmap1&0x01));
	trimvalue16bit = trimvalue16bit - 15;
	hircmap1 = trimvalue16bit&0x01;
	hircmap0 = trimvalue16bit>>1;
	TA=0XAA;
	TA=0X55;
	RCTRIM0 = hircmap0;
	TA=0XAA;
	TA=0X55;
	RCTRIM1 = hircmap1;
}



//=======================================================================================
// ܣUART0
//=======================================================================================
void UART0_Open(void)    
{
	P06_Quasi_Mode;		//Setting UART pin as Quasi mode for transmit
	P07_Quasi_Mode;		//Setting UART pin as Quasi mode for transmit
	P06   = 1;
	P07   = 1;
	SCON  = 0x50;     	//UART0 Mode1,REN=1
	clr_BRCK;			//UART0 baud rate clock source = Timer1
	clr_TR1;
	TMOD &= 0x0F;
	TMOD |= 0x20; 
	set_T1M;
	set_SMOD;			//UART0 Double Rate Enable
	TH1   = 0xF7;		/*16.6 MHz 115200*/
	TL1   = 0xF7;		/*16.6 MHz 115200*/
	set_TR1;			//Trigger Timer1
	set_TI;				//For printf function must setting TI = 1
}



//=======================================================================================
//ܣUART01ֽ
//c					 				  
//=======================================================================================
void UART0_Send_onebyte(uint8_t c)
{
	while(BIT_TI);
	BIT_TI= 1;
	SBUF  = c;
}


//=======================================================================================
//ܣUART0Nֽ
//datݵַ
//numֽ				 				  
//=======================================================================================
void UART0_Send_Nbytes(uint8_t *dat,uint16_t num)
{
	uint16_t i;
	for(i=0;i<num;i++)
	{
		UART0_Send_onebyte(dat[i]);
	}			
}





//=======================================================================================
//ܣUART0ַ
//strַָ\0
//=======================================================================================
void UART0_Send_String(char *str)
{
	uint16_t i;
	for(i=0;;i++)
	{
		if(str[i]=='\0')break;
		UART0_Send_onebyte(str[i]);
	}
}

//=======================================================================================
// 0жϷ
//=======================================================================================
void UART0_ISR(void) interrupt 4  
{
	if (RI)
	{// ݴ
		RI=0;										// ձ־λ
		u8Uart_Data[UartLast] = SBUF; 				// յ
		UartLast++;
		if(UartLast>=UARTLOOP)
			UartLast = 0;
	}
	if (TI)
	{// ֻ־λ
		TI = 0; 
		BIT_TI=0;
	}
}


//=======================================================================================
// ڽյݺٻشȥ                     
// TXD:P0.6
// RXD:P0.7
//=======================================================================================
void main (void)
{
  uint8_t i;
  MODIFY_HIRC_16588();
  UART0_Open();       //ѡtimer1ΪʱԴΪ115200
  ES=1;               //ʹܴ0жϣͺͽչһʹλ, Ҫжϳдɱ־
                      //ʹ˴жϾͲҪprintfпܿprintf
  EA = 1;             //ʹȫж
  UART0_Send_String ("*===================================================================\r\n");
  UART0_Send_String ("*  Name: N76E003 UART Sample Code.\r\n");
  UART0_Send_String ("*===================================================================\r\n");
  while(1)
  {
    while(UartLast != UartFirst)
    {
      i=UartLast; 
      if(i < UartFirst)
      {
        for(;UartFirst<UARTLOOP;UartFirst++)
            UART0_Send_onebyte(u8Uart_Data[UartFirst]);
        UartFirst=0;
      }
      if(i > UartFirst)
      {
        for(;UartFirst<i;UartFirst++)
            UART0_Send_onebyte(u8Uart_Data[UartFirst]);  
      }     
    }
 }
}
